#include <Time.h>  
#include <LiquidCrystal.h>

#define TIME_MSG_LEN  11   
#define TIME_HEADER  'T' 
#define TIME_REQUEST  7 
#define MEZ 7200 //Sommer
//#define MEZ 3600 //Winter
LiquidCrystal lcd(2, 3, 4, 5, 6, 7);  

void setup(){
  lcd.begin(16,2); 
  lcd.clear();
  Serial.begin(9600);
  setSyncProvider( requestSync);  
  Serial.println("Unix Timestamp eingeben:");
}

void loop(){    
  if(Serial.available()){
    processSyncMessage();
  }
  if(timeStatus()!= timeNotSet){
    digitalClockDisplay();  
  }
  delay(1000);
}

void digitalClockDisplay(){
  lcd.setCursor(0,0);
  lcd.print(hour());
  printDigits(minute());
  printDigits(second());
  lcd.setCursor(0,1);
  lcd.print(dayShortStr(weekday()));
  lcd.print(" ");
  lcd.print(day());
  lcd.print(".");
  lcd.print(month());
  lcd.print(".");
  lcd.print(year()); 
}

void printDigits(int digits){
  lcd.print(":");
  if(digits < 10){
    lcd.print('0');
  }
  lcd.print(digits);
}

void processSyncMessage(){
  while(Serial.available() >=  TIME_MSG_LEN ){ 
    char c = Serial.read() ; 
    if( c == TIME_HEADER ){       
      time_t pctime = 0;
      for(int i=0; i < TIME_MSG_LEN -1; i++){   
        c = Serial.read();          
        if( c >= '0' && c <= '9'){   
          pctime = (10 * pctime) + (c - '0') ; 
        }
      }   
      pctime += MEZ; 
      setTime(pctime);   
    }  
  }
}

time_t requestSync(){
  Serial.write(TIME_REQUEST);  
  return 0; 
}

