#include "Display.h"
#include "SPI.h"

Display lcd = Display();

void setup() {
  lcd.init(20);
}

void writeMeteringBar(byte page, byte data) {
  lcd.setPageAddress(page);
  lcd.setColumnAddress(0);
  for (byte i = 0; i < data; i++) {
    lcd.writeData(0xff);
  }
}

int getTemperature(void)
{
  ADMUX = (_BV(REFS1) | _BV(REFS0) | _BV(MUX3));
  ADCSRA |= _BV(ADEN);                            //Enable ADC
  delay(10);                                      //wait for voltage stabilisation
  ADCSRA |= _BV(ADSC);                            //Start ADC
  while(bit_is_set(ADCSRA, ADSC));                //wait for messurement
  return ADC;                                    //return value from ADCW register (ADCL and ADCH)
}

void loop() {
  lcd.clearDisplayRAM();
  byte value;

  value = analogRead(A0) >> 3;
  writeMeteringBar(0, value);
  writeMeteringBar(1, value);

  value = analogRead(A1) >> 3;
  writeMeteringBar(3, value);
  writeMeteringBar(4, value);

  value = getTemperature() & 0b00111111;          //Normalization
  writeMeteringBar(6, value);
  writeMeteringBar(7, value);

  delay(100);
}



