#include "Display.h"
#include "SPI.h"

#define LCD_BUTTON_LEFT SDA
#define LCD_BUTTON_RIGHT SCL 
#define LCD_BACKLIGHT 12

Display lcd = Display();

void setup() {
  pinMode(LCD_BUTTON_LEFT, INPUT_PULLUP);
  pinMode(LCD_BUTTON_RIGHT, INPUT_PULLUP);
  pinMode(LCD_BACKLIGHT, OUTPUT);
  digitalWrite(LCD_BACKLIGHT, HIGH);
  lcd.initSoftSPI(20);
  lcd.clearVideoBuffer();
  lcd.drawString(5, 10, "Hardware Playground");
  lcd.drawLine(0, 20, 127, 20);
  lcd.show();
}

void loop() {
  waitForInput();
  digitalWrite(LCD_BACKLIGHT, LOW);
  waitForInput();
  digitalWrite(LCD_BACKLIGHT, HIGH);
  lcd.writeCommand(0xA5);  //alle Pixel an
  waitForInput();
  lcd.writeCommand(0xA4);  //alle Pixel im Normalmodus 
  waitForInput();
  lcd.writeCommand(0xA7);  //Anzeige invertiert
  waitForInput();
  lcd.writeCommand(0xA6);  //Anzeige nichtinvertiert
  waitForInput();
  lcd.writeCommand(0xC0);  //Anzeige horizontal gespiegelt
  waitForInput();
  lcd.writeCommand(0xC8);  //Anzeige nicht horizontal gespiegelt
  waitForInput();
  lcd.writeCommand(0xA1);  //Anzeige vertikal gespiegelt
  lcd.show();              //nur wirksam nach neuschreiben des Display RAM
  waitForInput();
  lcd.writeCommand(0xA0);  //Anzeige nicht vertikal gespiegelt
  lcd.show();              //nur wirksam nach neuschreiben des Display RAM
}

void waitForInput() {
  delay(300);
  while (digitalRead(LCD_BUTTON_LEFT) && digitalRead(LCD_BUTTON_RIGHT)) {}
}


