#include "Display.h"
#include "SPI.h"

#define LCD_BUTTON_LEFT SDA
#define LCD_BUTTON_RIGHT SCL

Display lcd = Display();
byte position = 0;

void setup() {
  DDRD = B11111111;
  pinMode(LCD_BUTTON_LEFT, INPUT_PULLUP);
  pinMode(LCD_BUTTON_RIGHT, INPUT_PULLUP);
  lcd.init(20);

  lcd.drawString(1, 1, "Navigation");
  lcd.invertRectangle(0, 0, 60, 8);
  lcd.drawLine(60, 8, 127, 8);
  lcd.drawString(5, 55, "Auswahl");
  lcd.invertRectangle(0, 54, 50, 63);
  lcd.drawString(85, 55, "Toggle");
  lcd.invertRectangle(77, 54, 127, 63);

  for (byte x=0; x<8; x++) {
    char buffer[50];
    sprintf(buffer, "PIN %d", x); 
    if (x<4) {
      lcd.drawString(10, 16+8*x, buffer);
    } 
    else {
      lcd.drawString(90, 8+8*(x-3), buffer);
    }
  }
  invertItem(position);
  lcd.show();
}

void invertItem(byte position) {
  if (position<4) {
    lcd.invertRectangle(8, 7+8*(position+1), 40, 7+8*(position+2));
  } 
  else {
    lcd.invertRectangle(88, 7+8*(position-3), 120, 7+8*(position-2));
  }
}

void loop() {
  if (!digitalRead(LCD_BUTTON_LEFT)) {
    invertItem(position);
    position++;
    position=position&7;
    invertItem(position);

    lcd.show();
    delay(200);
  }
  if (!digitalRead(LCD_BUTTON_RIGHT)) {
    PIND = bit(position);
    delay(200);
  }
}



